Xapian: API Documentation: xapian-core: Xapian::DecreasingValueWeightPostingSource Class Reference

# Xapian::DecreasingValueWeightPostingSource Class Reference

Read weights from a value which is known to decrease as docid increases. More...

Inheritance diagram for Xapian::DecreasingValueWeightPostingSource:

[legend]

List of all members.

## Public Member Functions
Xapian::weight | get_weight () const
| Return the weight contribution for the current document.
DecreasingValueWeightPostingSource * | clone () const
| Clone the posting source.
std::string | name () const
| Name of the posting source class.
std::string | serialise () const
| Serialise object parameters into a string.
DecreasingValueWeightPostingSource * | unserialise (const std::string &s) const
| Create object given string serialisation returned by serialise().
void | init (const Xapian::Database &db_)
| Set this PostingSource to the start of the list of postings.
void | next (Xapian::weight min_wt)
| Advance the current position to the next matching document.
void | skip_to (Xapian::docid min_docid, Xapian::weight min_wt)
| Advance to the specified docid.
bool | check (Xapian::docid min_docid, Xapian::weight min_wt)
| Check if the specified docid occurs.
std::string | get_description () const
| Return a string describing this object.
## Protected Member Functions
void | skip_if_in_range (Xapian::weight min_wt)
| Skip the iterator forward if in the decreasing range, and weight is low.
## Protected Attributes
bool | items_at_end
| Flag, set to true if there are docs after the end of the range.

## Detailed Description

Read weights from a value which is known to decrease as docid increases.

This posting source can be used, like ValueWeightPostingSource, to add a weight contribution to a query based on the values stored in a slot. The values in the slot must be serialised as by sortable_serialise().

However, this posting source is additionally given a range of document IDs, within which the weight is known to be decreasing. ie, for all documents with ids A and B within this range (including the endpoints), where A is less than B, the weight of A is less than or equal to the weight of B. This can allow the posting source to skip to the end of the range quickly if insufficient weight is left in the posting source for a particular source.

By default, the range is assumed to cover all document IDs.

The ordering property can be arranged at index time, or by sorting an indexed database to produce a new, sorted, database.

## Member Function Documentation

bool Xapian::DecreasingValueWeightPostingSource::check | ( | Xapian::docid | did,
|  | Xapian::weight | min_wt |
| ) |  |  | `[virtual]`

Check if the specified docid occurs.

The caller is required to ensure that the specified document id did actually exists in the database. If it does, it must move to that document id, and return true. If it does not, it may either:

- return true, having moved to a definite position (including "at_end"), which must be the same position as skip_to() would have moved to.

or

- return false, having moved to an "indeterminate" position, such that a subsequent call to next() or skip_to() will move to the next matching position after did.

Generally, this method should act like skip_to() and return true if that can be done at little extra cost.

Otherwise it should simply check if a particular docid is present, returning true if it is, and false if it isn't.

The default implementation calls skip_to() and always returns true.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Reimplemented from Xapian::ValuePostingSource.

DecreasingValueWeightPostingSource* Xapian::DecreasingValueWeightPostingSource::clone | ( |  | ) | const`[virtual]`

Clone the posting source.

The clone should inherit the configuration of the parent, but need not inherit the state. ie, the clone does not need to be in the same iteration position as the original: the matcher will always call init() on the clone before attempting to move the iterator, or read the information about the current position of the iterator.

This may return NULL to indicate that cloning is not supported. In this case, the PostingSource may only be used with a single-database search.

The default implementation returns NULL.

Note that the returned object will be deallocated by Xapian after use with "delete". It must therefore have been allocated with "new".

Reimplemented from Xapian::ValueWeightPostingSource.

std::string Xapian::DecreasingValueWeightPostingSource::get_description | ( |  | ) | const`[virtual]`

Return a string describing this object.

This default implementation returns a generic answer. This default it provided to avoid forcing those deriving their own PostingSource subclass from having to implement this (they may not care what get_description() gives for their subclass).

Reimplemented from Xapian::ValueWeightPostingSource.

Xapian::weight Xapian::DecreasingValueWeightPostingSource::get_weight | ( |  | ) | const`[virtual]`

Return the weight contribution for the current document.

This default implementation always returns 0, for convenience when implementing "weight-less" PostingSource subclasses.

This method may assume that it will only be called when there is a "current document". In detail: Xapian will always call init() on a PostingSource before calling this for the first time. It will also only call this if the PostingSource reports that it is pointing to a valid document (ie, it will not call it before calling at least one of next(), skip_to() or check(), and will ensure that the PostingSource is not at the end by calling at_end()).

Reimplemented from Xapian::ValueWeightPostingSource.

void Xapian::DecreasingValueWeightPostingSource::init | ( | const Xapian::Database & | db | ) | `[virtual]`

Set this PostingSource to the start of the list of postings.

This is called automatically by the matcher prior to each query being processed.

If a PostingSource is used for multiple searches, init() will therefore be called multiple times, and must handle this by using the database passed in the most recent call.

Parameters:

  | db | The database which the PostingSource should iterate through.

Note: the database supplied to this method must not be modified: in particular, the reopen() method should not be called on it.

Note: in the case of a multi-database search, a separate PostingSource will be used for each database (the separate PostingSources will be obtained using clone()), and each PostingSource will be passed one of the sub-databases as the db parameter here. The db parameter will therefore always refer to a single database. All docids passed to, or returned from, the PostingSource refer to docids in that single database, rather than in the multi-database.

Reimplemented from Xapian::ValueWeightPostingSource.

std::string Xapian::DecreasingValueWeightPostingSource::name | ( |  | ) | const`[virtual]`

Name of the posting source class.

This is used when serialising and unserialising posting sources; for example, for performing remote searches.

If the subclass is in a C++ namespace, the namespace should be included in the name, using "::" as a separator. For example, for a PostingSource subclass called "FooPostingSource" in the "Xapian" namespace the result of this call should be "Xapian::FooPostingSource".

This should only be implemented if serialise() and unserialise() are also implemented. The default implementation returns an empty string.

If this returns an empty string, Xapian will assume that serialise() and unserialise() are not implemented.

Reimplemented from Xapian::ValueWeightPostingSource.

void Xapian::DecreasingValueWeightPostingSource::next | ( | Xapian::weight | min_wt | ) | `[virtual]`

Advance the current position to the next matching document.

The PostingSource starts before the first entry in the list, so next() must be called before any methods which need the context of the current position.

Xapian will always call init() on a PostingSource before calling this for the first time.

Parameters:

  | min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::ValuePostingSource.

std::string Xapian::DecreasingValueWeightPostingSource::serialise | ( |  | ) | const`[virtual]`

Serialise object parameters into a string.

The serialised parameters should represent the configuration of the posting source, but need not (indeed, should not) represent the current iteration state.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::ValueWeightPostingSource.

void Xapian::DecreasingValueWeightPostingSource::skip_to | ( | Xapian::docid | did,
|  | Xapian::weight | min_wt |
| ) |  |  | `[virtual]`

Advance to the specified docid.

If the specified docid isn't in the list, position ourselves on the first document after it (or at_end() if no greater docids are present).

If the current position is already the specified docid, this method will leave the position unmodified.

If the specified docid is earlier than the current position, the behaviour is unspecified. A sensible behaviour would be to leave the current position unmodified, but it is also reasonable to move to the specified docid.

The default implementation calls next() repeatedly, which works but skip_to() can often be implemented much more efficiently.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Parameters:

  | min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::ValuePostingSource.

DecreasingValueWeightPostingSource* Xapian::DecreasingValueWeightPostingSource::unserialise | ( | const std::string & | s | ) | const`[virtual]`

Create object given string serialisation returned by serialise().

Note that the returned object will be deallocated by Xapian after use with "delete". It must therefore have been allocated with "new".

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Parameters:

  | s | A serialised instance of this PostingSource subclass.

Reimplemented from Xapian::ValueWeightPostingSource.

The documentation for this class was generated from the following file:

- xapian/postingsource.h